"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.swallowHalt = exports.isHaltError = exports.HaltError = void 0;
class HaltError extends Error {
    get __isEffectionHaltError() {
        return true;
    }
    constructor() {
        super("halted");
    }
}
exports.HaltError = HaltError;
// eslint-disable-next-line @typescript-eslint/no-explicit-any, @typescript-eslint/explicit-module-boundary-types
function isHaltError(value) {
    return !!(value && value.__isEffectionHaltError);
}
exports.isHaltError = isHaltError;
function swallowHalt(error) {
    if (!isHaltError(error)) {
        throw error;
    }
    else {
        return undefined;
    }
}
exports.swallowHalt = swallowHalt;
//# sourceMappingURL=halt-error.js.map