export function addTrace(error, task) {
    let info = {
        id: task.id,
        type: task.type,
        labels: task.labels,
        state: task.state,
    };
    return Object.create(error, {
        name: {
            get: () => error.name,
            enumerable: true,
        },
        message: {
            get: () => error.message,
            enumerable: true,
        },
        cause: {
            get: () => error,
            enumerable: true,
        },
        effectionTrace: {
            value: [...(error.effectionTrace || []), info],
            enumerable: true,
        }
    });
}
//# sourceMappingURL=error.js.map