export class HaltError extends Error {
    get __isEffectionHaltError() {
        return true;
    }
    constructor() {
        super("halted");
    }
}
// eslint-disable-next-line @typescript-eslint/no-explicit-any, @typescript-eslint/explicit-module-boundary-types
export function isHaltError(value) {
    return !!(value && value.__isEffectionHaltError);
}
export function swallowHalt(error) {
    if (!isHaltError(error)) {
        throw error;
    }
    else {
        return undefined;
    }
}
//# sourceMappingURL=halt-error.js.map