import { Operation } from '../operation';
/**
 * Throw an error after the given amount of milliseconds. See also {@link withTimeout}.
 *
 * ### Example
 *
 * ```typescript
 * import { main, spawn, timeout } from 'effection';
 *
 * main(function*() {
 *   yield spawn(timeout(2000));
 *   yield fetch('http://google.com');
 * });
 * ```
 *
 * @param duration the timeout duration in milliseconds
 */
export declare function timeout(duration: number): Operation<never>;
//# sourceMappingURL=timeout.d.ts.map